 
/*{{{  Includes*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <dirent.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
/*}}}  */
/*{{{  Defines*/

#define MAX_FILETYPES 100

#define MenuDY    15
#define MenuSumY  20

#define F_TYPE_UNKNOWN   0
#define F_TYPE_O         1
#define F_TYPE_BAK       2
#define F_TYPE_STANDARD  10


#define ICON_DSTART_X  10
#define ICON_DSTART_Y  60
#define ICON_FSTART_X  10
#define ICON_FSTART_Y  15
#define ICON_SPACE_X  100
#define ICON_SIZE_X   45
#define ICON_SIZE_Y   45

/* The character that inverts a character class; '!' or '^'. */
#define INVERT '!'

/*}}}  */
/*{{{  Globale Variablen*/
extern int      file_entry_cnt, dir_entry_cnt;
extern char    **file_list, **dir_list;
extern char    **filelist, **dirlist;

extern int ICON_D_SPACE_Y;
extern int ICON_F_SPACE_Y;
extern int ICON_COUNT_X ;

extern int CONFIG_XDESKTOP;

extern int DOS_FLOPPY_MOUNTED;
extern int MINIX_FLOPPY_MOUNTED;

extern  int      file_entry_cnt, dir_entry_cnt;
extern  char    **file_list, **dir_list;
extern  char    **filelist, **dirlist;

extern XImage *DateiImage;
extern XImage *LinkImage;

extern int icon_d_start;
extern int icon_f_start;
extern int icon_f_offset_y;
/*{{{  ConText*/
typedef struct {
  int XA,YA,XB,YB;
  char key[257];
  Display *dpy;
  Window window;
  GC gc;
  Screen *screen;
  long black;
  long blue;
  long green;
  long cyan;
  long red;
  long magenta;
  long brown;
  long lgray;
  long dgray;
  long lblue;
  long lgreen;
  long lred;
  long lmagenta;
  long lcyan;
  long yellow;
  long white;
  int is_a_key_waiting;
  } XbWDSy_XbWContxt;
/*}}}  */

extern XbWDSy_XbWContxt XbWVSy_ConTxt;
 
extern  unsigned long int XbWVGr_ColorValues[64];

extern int XbWVMs_XPos;
extern int XbWVMs_YPos;
 
extern int icon_x;
extern int icon_y;


/*}}}  */
/*{{{  Globales Setup*/

/* IO-Struct Descr for group SETUPA created by XW */

typedef struct {
 short NoDirt;
 short NoBackups;
 short NoUnknown;
 short ASK_BEFORE_DELETE;
 char DirMenuLabel[20][200];
 char DirMenuAction[20][200];
 char FileMenuLabel[20][200];
 char FileMenuAction[20][200];
 char UserMenuLabel[20][200];
 char UserMenuAction[20][200];
 char StandardLabel[100][200];
 char StandardAction[100][200];
 char StandardIcon[100][200];
 short StandardFCol[100];
 short StandardBCol[100];
 char cur_dir[200];
 char dirmask[200];
 char XbWVGr_ColorTexte[32][200];
 short draw_icon;
 short bigsize;
 short winw;
 short winh;
 short maxy;
 char wname[200];
 short NENTRIES;
 char ShowMSG1[200];
 char ShowMSG2[200];
 char ShowMSG3[200];
 char ShowMSG4[200];
 char ShowMSG5[200];
} DATA_SETUP;

 
extern DATA_SETUP SETUP;

/*}}}  */


int wild_match(char *string, char *pattern);
int GetUserRequest(int xa, int ya, char *stra, char *strb, char *req);
int GetUserAnswer(int xa, int ya, char *stra, char *strb,
    char *msg1, char *msg2, char *msg3);
 
int ExecCommandLine(char *cmd, char *name, char *lname, int xa, int ya);

void LoadImages(void);
void FreeImages(void);
void ClearImages(void);
int GetFileType(char *name);
int ShowFileIcon(char *name, char *sname);
int ClickFileIcon(char *name, char *sname, int xa, int ya);
int StarteAktion(int mausx, int mausy);


int ShowDirectory(void);
int ClickFileAction(int xa, int ya, char *name, char *sname);

void SaveSetup(char *name);
void LoadSetup(char *name);
 
void XbWSMs_SetClockCursor(void);
void XbWSMs_SetArrowCursor(void);
 
